package org.astakhova.test;

import junit.framework.TestCase;
import org.astakhova.reader.FileReader;
import java.io.*;
import org.astakhova.data.IDiagram;
import org.astakhova.data.impl.Diagram;

public class JTestReader extends TestCase {
	
	//Patterns for this tester are formed while testing Writer
	
	public void testReader1() {
		compare("test/writer/test1.txt", "test/reader/pattern/test1.txt");
	}
	
	public void testReader2() {
		compare("test/writer/test2.txt", "test/reader/pattern/test2.txt");
	}
	
	public void testReader3() {
		compare("test/reader/test3.bde", "test/reader/pattern/test3.txt");
	}
	
	/*public void testReader4() {
		String s = "The diagram description:\nThe node description:\n" +
		"its text: A\nits coordinates: 100 100\n\nThe node des" +
		"cription:\nits text: B\nits coordinates: 200 200\nthe " +
		"outArrow:\nnull\nthe outArrow:\nnull\n\n";
		assertEquals(s, readDiagram("C:/Documents and Settings//" +
				" /Julia//Borland Academy/WorkS" +
				"pace/BlockDiagram/test/reader/test3.xml").toString());
	}*/
	
	public void testReader5() {
		compare("test/writer/test3.txt", "test/reader/pattern/test5.txt");
	}
	
	public void testReader6() {
		compare("test/writer/test4.txt", "test/reader/pattern/test6.txt");
	}
	
	private IDiagram readDiagram(String fileName) {
		try {
			IDiagram d = new Diagram();
			FileReader fr = new FileReader(new File(fileName));
			fr.read(d);
			return d;
		} catch (Exception e) {
			throw new RuntimeException(e.getMessage());
		}
	}
	
	private void compare(String diagram, String pattern) {
		String s = readDiagram(diagram).toString();
		try {
			java.io.FileWriter fw = new java.io.FileWriter(pattern);
			fw.write(s);
			fw.close();
			StringReader sr = new StringReader(s);
			java.io.FileReader fr = 
				new java.io.FileReader(pattern);
			int a, b;
			while (((a = sr.read()) >= 0) && ((b = fr.read()) >= 0))
				assertEquals(a, b);
			sr.close();
			fr.close();
		} catch(Exception e) {
			throw new RuntimeException();
		}
	}
}
