package org.astakhova.view;

import org.astakhova.data.*;
import java.awt.Graphics;
import java.awt.Rectangle;

/**
 * Makes a description of a Begin and End block
 * @author Astakhova Julia A.
 */
public class BeginEndBlock extends Block {
	private static final long serialVersionUID = 1;
	
	/**
	 * Creates a new Begin block
	 * @param n a Begin node block is created for
	 */
	public BeginEndBlock(IBeginNode n) {
		super(n);
	}
	
	/**
	 * Creates a new End block
	 * @param n an End node block is created for
	 */
	public BeginEndBlock(IEndNode n) {
		super(n);
	}
	
	protected void paintBlock(Graphics g) {
		Rectangle r = getParameters();
		g.drawOval(r.x, r.y, r.width, r.height);
	}
	
	public void setTextArea() {
		Rectangle r = getParameters();
		int x = r.x + r.width/4, y = r.y + r.height/6;
		int w = r.width - (x - r.x)*2;
		int h = r.height - (y - r.y)*2;
		setTextArea(new Rectangle(x, y, w, h));
	}
}
