package org.astakhova.view;

import java.awt.event.*;
import javax.swing.*;

/**
 * Makes a description for the block label edit key listener.
 * Process pressing of Enter and Esc keys
 * @author Astakhova Julia A.
 */
public class BlockLabelEditL extends KeyAdapter {
	private DiagramForm myForm;
	
	/**
	 * Creates a new block label listener
	 * @param df diagram form containing the block
	 */
	public BlockLabelEditL(DiagramForm df) {
		myForm = df;
	}
	
	public void keyPressed(KeyEvent ke) {
		//Checks if the block is selected and has active editable label
		if (myForm.getSelectedBlock() != null &&
				myForm.getSelectedBlock().getBlock().getEditableComponent() != null) {
			
			JTextField tf = myForm.getSelectedBlock().
				getBlock().getEditableComponent();
			Selection selection = myForm.getSelectedBlock();
			
			if (ke.getKeyCode() == KeyEvent.VK_ENTER) {
				String s = tf.getText();
				String ss = selection.getBlock().getNode().getText();
				selection.getBlock().getNode().setText(s);
				myForm.getContentPane().remove(tf);
				selection.getBlock().setEditableComponent(null);
				if (!s.equals(ss))
					myForm.fixChanges();
				myForm.repaint();
			}
			
			if (ke.getKeyCode() == KeyEvent.VK_ESCAPE) {
				myForm.getContentPane().remove(tf);
				selection.getBlock().setEditableComponent(null);
				myForm.repaint();
			}
		}
	}
}
