package org.astakhova.view.listener;

import javax.swing.event.MouseInputAdapter;
import org.astakhova.view.DiagramForm;

/**
 * Makes a description for diagram form's mouse listener
 * @author Astakhova Julia A
 */
public abstract class MouseL extends MouseInputAdapter {
	private DiagramForm myForm;
	
	/**
	 * Binds listener to the diagram form
	 * @param df diagram form
	 */
	public void setForm(DiagramForm df) {
		myForm = df;
		myForm.setUnselected();
	}
	
	public DiagramForm getForm() {
		return myForm;
	}
	
	/**
	 * Checks if the listener can perform its action when an event occurs
	 * @return true if the listener can perform its action when an event occurs
	 */
	public boolean isPossible() {
		return true;
	}
}