package org.astakhova.view.listener;

import java.awt.event.MouseEvent;
import org.astakhova.view.*;
import org.astakhova.view.param.*;

/**
 * Makes a description of mouse listener for "create block" action button
 * @author Astakhova Julia A.
 */
public class NewBlockMouseL extends MouseL {
	private BlockFactory myBlockFactory;
	
	public NewBlockMouseL(BlockFactory bf) {
		myBlockFactory = bf;
	}
		
	public void mouseClicked(MouseEvent e) {
		Block n = myBlockFactory.newInstance(
				getForm().getDiagram(), POffset.getX(e.getX()), POffset.getY(e.getY()));
		if (n == null)
			return;
		getForm().getOwner().checkButtonPossibility();
		getForm().fixChanges();
		getForm().getContentPane().add(n);
		getForm().repaint();	
	}	
	
	public boolean isPossible() {
		return true;
	}
}
